Package icyllis.modernui.widget

# Class HorizontalScrollView

java.lang.Object
icyllis.modernui.view.View
icyllis.modernui.view.ViewGroup
icyllis.modernui.widget.FrameLayout
icyllis.modernui.widget.HorizontalScrollView

All Implemented Interfaces:
  `Drawable.Callback`, `ViewManager`, `ViewParent`

public class HorizontalScrollView extends FrameLayout
Layout container for a view hierarchy that can be scrolled by the user, allowing it to be larger than the physical display. A HorizontalScrollView is a `FrameLayout`, meaning you should place one child in it containing the entire contents to scroll; this child may itself be a layout manager with a complex hierarchy of objects. A child that is often used is a `LinearLayout` in a horizontal orientation, presenting a horizontal array of top-level items that the user can scroll through.

The `TextView` class also takes care of its own scrolling, so does not require a HorizontalScrollView, but using the two together is possible to achieve the effect of a text view within a larger container.

HorizontalScrollView only supports horizontal scrolling. For vertical scrolling, use either `ScrollView` or `ListView`.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class icyllis.modernui.widget.FrameLayout

  `FrameLayout.LayoutParams`

  ## Nested classes/interfaces inherited from class icyllis.modernui.view.ViewGroup

  `ViewGroup.MarginLayoutParams`

  ## Nested classes/interfaces inherited from class icyllis.modernui.view.View

  `View.DragShadow, View.Focusable, View.FocusableMode, View.FocusDirection, View.FocusRealDirection, View.LayoutDir, View.NestedScrollType, View.OnAttachStateChangeListener, View.OnClickListener, View.OnContextClickListener, View.OnCreateContextMenuListener, View.OnDragListener, View.OnFocusChangeListener, View.OnGenericMotionListener, View.OnHoverListener, View.OnKeyListener, View.OnLayoutChangeListener, View.OnLongClickListener, View.OnScrollChangeListener, View.OnTouchListener, View.ResolvedLayoutDir, View.ScrollAxis, View.ScrollBarStyle, View.ScrollIndicators, View.TextAlignment, View.Visibility`

- ## Field Summary

  ### Fields inherited from class icyllis.modernui.view.ViewGroup

  `CLIP_TO_PADDING_MASK, FLAG_DISALLOW_INTERCEPT, FOCUS_AFTER_DESCENDANTS, FOCUS_BEFORE_DESCENDANTS, FOCUS_BLOCK_DESCENDANTS`

  ### Fields inherited from class icyllis.modernui.view.View

  `ALPHA, BOTTOM, EMPTY_STATE_SET, ENABLED_FOCUSED_SELECTED_STATE_SET, ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_FOCUSED_STATE_SET, ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, ENABLED_SELECTED_STATE_SET, ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, ENABLED_STATE_SET, ENABLED_WINDOW_FOCUSED_STATE_SET, FOCUS_BACKWARD, FOCUS_DOWN, FOCUS_FORWARD, FOCUS_LEFT, FOCUS_RIGHT, FOCUS_UP, FOCUSABLE, FOCUSABLE_AUTO, FOCUSABLES_ALL, FOCUSABLES_TOUCH_MODE, FOCUSED_SELECTED_STATE_SET, FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, FOCUSED_STATE_SET, FOCUSED_WINDOW_FOCUSED_STATE_SET, GONE, HAPTIC_FEEDBACK_ENABLED, INVISIBLE, LAYOUT_DIRECTION_INHERIT, LAYOUT_DIRECTION_LOCALE, LAYOUT_DIRECTION_LTR, LAYOUT_DIRECTION_RTL, LAYOUT_DIRECTION_UNDEFINED, LEFT, MEASURED_HEIGHT_STATE_SHIFT, MEASURED_SIZE_MASK, MEASURED_STATE_MASK, MEASURED_STATE_TOO_SMALL, mPaddingBottom, mPaddingLeft, mPaddingRight, mPaddingTop, mScrollX, mScrollY, NO_ID, NOT_FOCUSABLE, OVER_SCROLL_ALWAYS, OVER_SCROLL_IF_CONTENT_SCROLLS, OVER_SCROLL_NEVER, PRESSED_ENABLED_FOCUSED_SELECTED_STATE_SET, PRESSED_ENABLED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_STATE_SET, PRESSED_ENABLED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_SELECTED_STATE_SET, PRESSED_ENABLED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_ENABLED_STATE_SET, PRESSED_ENABLED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_SELECTED_STATE_SET, PRESSED_FOCUSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_FOCUSED_STATE_SET, PRESSED_FOCUSED_WINDOW_FOCUSED_STATE_SET, PRESSED_SELECTED_STATE_SET, PRESSED_SELECTED_WINDOW_FOCUSED_STATE_SET, PRESSED_STATE_SET, PRESSED_WINDOW_FOCUSED_STATE_SET, RIGHT, ROTATION, ROTATION_X, ROTATION_Y, SCALE_X, SCALE_Y, SCROLL_AXIS_HORIZONTAL, SCROLL_AXIS_NONE, SCROLL_AXIS_VERTICAL, SCROLL_INDICATOR_BOTTOM, SCROLL_INDICATOR_END, SCROLL_INDICATOR_LEFT, SCROLL_INDICATOR_RIGHT, SCROLL_INDICATOR_START, SCROLL_INDICATOR_TOP, SCROLL_X, SCROLL_Y, SCROLLBARS_INSIDE_INSET, SCROLLBARS_INSIDE_OVERLAY, SCROLLBARS_OUTSIDE_INSET, SCROLLBARS_OUTSIDE_OVERLAY, SELECTED_STATE_SET, SELECTED_WINDOW_FOCUSED_STATE_SET, SOUND_EFFECTS_ENABLED, TEXT_ALIGNMENT_CENTER, TEXT_ALIGNMENT_GRAVITY, TEXT_ALIGNMENT_INHERIT, TEXT_ALIGNMENT_TEXT_END, TEXT_ALIGNMENT_TEXT_START, TEXT_ALIGNMENT_VIEW_END, TEXT_ALIGNMENT_VIEW_START, TEXT_DIRECTION_ANY_RTL, TEXT_DIRECTION_FIRST_STRONG, TEXT_DIRECTION_FIRST_STRONG_LTR, TEXT_DIRECTION_FIRST_STRONG_RTL, TEXT_DIRECTION_INHERIT, TEXT_DIRECTION_LOCALE, TEXT_DIRECTION_LTR, TEXT_DIRECTION_RTL, TOP, TRANSLATION_X, TRANSLATION_Y, TRANSLATION_Z, TYPE_NON_TOUCH, TYPE_TOUCH, VIEW_MARKER, VISIBLE, WINDOW_FOCUSED_STATE_SET, X, Y, Z`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `HorizontalScrollView(Context context)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addView(View child)`
  Adds a child view.
  `void`
  `addView(View child, int index)`
  Adds a child view.
  `void`
  `addView(View child, int index, ViewGroup.LayoutParams params)`
  Adds a child view with the specified layout parameters.
  `void`
  `addView(View child, ViewGroup.LayoutParams params)`
  Adds a child view with the specified layout parameters.
  `boolean`
  `arrowScroll(int direction)`
  Handle scrolling in response to a left or right arrow click.
  `protected int`
  `computeHorizontalScrollOffset()`
  Compute the horizontal offset of the horizontal scrollbar's thumb within the horizontal range.
  `protected int`
  `computeHorizontalScrollRange()`
  The scroll range of a scroll view is the overall width of all of its children.
  `void`
  `computeScroll()`
  Called by a parent to request that a child update its values for mScrollX and mScrollY if necessary.
  `protected int`
  `computeScrollDeltaToGetChildRectOnScreen(Rect rect)`
  Compute the amount to scroll in the X direction in order to get a rectangle completely on the screen (or, if taller than the screen, at least the first screen size chunk of it).
  `boolean`
  `dispatchKeyEvent(KeyEvent event)`
  Dispatch a key event to the next view on the focus path.
  `void`
  `draw(Canvas canvas)`
  Base method that directly draws this view and its background, foreground, overlay and all children to the given canvas.
  `boolean`
  `executeKeyEvent(KeyEvent event)`
  You can call this function yourself to have the scroll view perform scrolling from a key event, just as if the event had been dispatched to it by the view hierarchy.
  `void`
  `fling(int velocityX)`
  Fling the scroll view
  `boolean`
  `fullScroll(int direction)`
  Handles scrolling in response to a "home/end" shortcut press.
  `BlendMode`
  `getLeftEdgeEffectBlendMode()`
  `int`
  `getLeftEdgeEffectColor()`
  Returns the left edge effect color.
  `BlendMode`
  `getRightEdgeEffectBlendMode()`
  `int`
  `getRightEdgeEffectColor()`
  Returns the right edge effect color.
  `boolean`
  `isFillViewport()`
  Indicates whether this HorizontalScrollView's content is stretched to fill the viewport.
  `boolean`
  `isSmoothScrollingEnabled()`
  `protected void`
  `measureChild(View child, int parentWidthMeasureSpec, int parentHeightMeasureSpec)`
  Ask one of the children of this view to measure itself, taking into account both the MeasureSpec requirements for this view and its padding.
  `protected void`
  `measureChildWithMargins(View child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)`
  Ask one of the children of this view to measure itself, taking into account both the MeasureSpec requirements for this view and its padding and margins.
  `boolean`
  `onGenericMotionEvent(MotionEvent event)`
  Implement this method to handle generic motion events.
  `boolean`
  `onInterceptTouchEvent(MotionEvent ev)`
  Implement this method to intercept all touch screen motion events.
  `protected void`
  `onLayout(boolean changed, int l, int t, int r, int b)`
  Called from `View.layout(int, int, int, int)` when this view should assign a size and position to each of its children.
  `protected void`
  `onMeasure(int widthMeasureSpec, int heightMeasureSpec)`
  Measure the view and its content to determine the measured width and the measured height.
  `protected void`
  `onOverScrolled(int scrollX, int scrollY, boolean clampedX, boolean clampedY)`
  Called by `View.overScrollBy(int, int, int, int, int, int, int, int, boolean)` to respond to the results of an over-scroll operation.
  `protected boolean`
  `onRequestFocusInDescendants(int direction, Rect previouslyFocusedRect)`
  When looking for focus in children of a scroll view, need to be a little more careful not to give focus to something that is scrolled off-screen.
  `protected void`
  `onSizeChanged(int w, int h, int oldw, int oldh)`
  Called when width or height changed
  `boolean`
  `onTouchEvent(MotionEvent ev)`
  Implement this method to handle touch screen motion events.
  `boolean`
  `pageScroll(int direction)`
  Handles scrolling in response to a "page up/down" shortcut press.
  `void`
  `requestChildFocus(View child, View focused)`
  Called when a child of this parent wants focus
  `boolean`
  `requestChildRectangleOnScreen(View child, Rect rectangle, boolean immediate)`
  Called when a child of this group wants a particular rectangle to be positioned onto the screen.
  `void`
  `requestDisallowInterceptTouchEvent(boolean disallowIntercept)`
  Called when a child does not want this parent and its ancestors to intercept touch events with `ViewGroup.onInterceptTouchEvent(MotionEvent)`.
  `void`
  `requestLayout()`
  Call this when something has changed which has invalidated the layout of this view.
  `void`
  `scrollTo(int x, int y)`
  Set the scrolled position of your view.
  `void`
  `setEdgeEffectColor(int color)`
  Sets the edge effect color for both left and right edge effects.
  `void`
  `setFillViewport(boolean fillViewport)`
  Indicates this HorizontalScrollView whether it should stretch its content width to fill the viewport or not.
  `void`
  `setLeftEdgeEffectBlendMode(BlendMode blendMode)`
  Sets the left edge effect blend mode, the default is `EdgeEffect.DEFAULT_BLEND_MODE`.
  `void`
  `setLeftEdgeEffectColor(int color)`
  Sets the left edge effect color.
  `void`
  `setRightEdgeEffectBlendMode(BlendMode blendMode)`
  Sets the right edge effect blend mode, the default is `EdgeEffect.DEFAULT_BLEND_MODE`.
  `void`
  `setRightEdgeEffectColor(int color)`
  Sets the right edge effect color.
  `void`
  `setSmoothScrollingEnabled(boolean smoothScrollingEnabled)`
  Set whether arrow scrolling will animate its transition.
  `boolean`
  `shouldDelayChildPressedState()`
  Return true if the pressed state should be delayed for children or descendants of this ViewGroup.
  `final boolean`
  `smoothScrollBy(int delta)`
  Like `View.scrollBy(int, int)`, but scroll smoothly instead of immediately.
  `final void`
  `smoothScrollTo(int x)`
  Like `scrollTo(int, int)`, but scroll smoothly instead of immediately.

  ### Methods inherited from class icyllis.modernui.widget.FrameLayout

  `checkLayoutParams, generateDefaultLayoutParams, generateLayoutParams, getMeasureAllChildren, setForegroundGravity, setMeasureAllChildren`

  ### Methods inherited from class icyllis.modernui.view.ViewGroup

  `addFocusables, addKeyboardNavigationClusters, addStatesFromChildren, addTouchables, addTransientView, addView, addViewInLayout, addViewInLayout, attachViewToParent, bringChildToFront, childDrawableStateChanged, childHasTransientStateChanged, cleanupLayoutState, clearChildFocus, clearDisappearingChildren, clearFocus, detachAllViewsFromParent, detachViewFromParent, detachViewFromParent, detachViewsFromParent, dispatchDraw, dispatchDrawableHotspotChanged, dispatchFinishTemporaryDetach, dispatchGenericPointerEvent, dispatchHoverEvent, dispatchKeyShortcutEvent, dispatchSetActivated, dispatchSetPressed, dispatchSetSelected, dispatchStartTemporaryDetach, dispatchTouchEvent, dispatchVisibilityChanged, dispatchWindowFocusChanged, dispatchWindowVisibilityChanged, drawableStateChanged, drawChild, endViewTransition, findFocus, findViewByPredicateTraversal, findViewTraversal, focusableViewAvailable, focusSearch, getChildAt, getChildCount, getChildDrawingOrder, getChildDrawingOrder, getChildMeasureSpec, getChildVisibleRect, getChildVisibleRect, getClipChildren, getClipToPadding, getDescendantFocusability, getFocusedChild, getLayoutTransition, getNestedScrollAxes, getTouchscreenBlocksFocus, getTransientView, getTransientViewCount, getTransientViewIndex, hasBooleanFlag, hasFocus, hasTransientState, indexOfChild, internalSetPadding, isChildrenDrawingOrderEnabled, isLayoutSuppressed, isTransitionGroup, jumpDrawablesToCurrentState, layout, measureChildren, offsetChildrenTopAndBottom, offsetDescendantRectToMyCoords, offsetRectIntoDescendantCoords, onChildVisibilityChanged, onCreateDrawableState, onInterceptHoverEvent, onNestedFling, onNestedPreFling, onNestedPreScroll, onNestedScroll, onNestedScrollAccepted, onResolvePointerIcon, onSetLayoutParams, onStartNestedScroll, onStopNestedScroll, onViewAdded, onViewRemoved, removeAllViews, removeAllViewsInLayout, removeDetachedView, removeTransientView, removeView, removeViewAt, removeViewInLayout, removeViews, removeViewsInLayout, requestFocus, requestTransitionStart, resetResolvedDrawables, resolveDrawables, resolveLayoutDirection, resolveLayoutParams, resolvePadding, resolveRtlPropertiesIfNeeded, resolveTextAlignment, resolveTextDirection, restoreDefaultFocus, setAddStatesFromChildren, setBooleanFlag, setChildrenDrawingOrderEnabled, setClipChildren, setClipToPadding, setDescendantFocusability, setLayoutTransition, setTouchscreenBlocksFocus, setTransitionGroup, showContextMenuForChild, startActionModeForChild, startViewTransition, suppressLayout, transformPointToViewLocal, updateViewLayout`

  ### Methods inherited from class icyllis.modernui.view.View

  `addFocusables, addOnAttachStateChangeListener, addOnLayoutChangeListener, awakenScrollBars, awakenScrollBars, callOnClick, cancelLongPress, cancelPendingInputEvents, canReceivePointerEvents, canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, canScrollHorizontally, canScrollVertically, combineMeasuredStates, computeHorizontalScrollExtent, computeVerticalScrollExtent, computeVerticalScrollOffset, computeVerticalScrollRange, createContextMenu, dispatchGenericMotionEvent, dispatchNestedFling, dispatchNestedPreFling, dispatchNestedPreScroll, dispatchNestedScroll, dispatchPointerEvent, dp, drawableHotspotChanged, findViewById, findViewByPredicate, findViewByPredicateInsideOut, focusSearch, forceHasOverlappingRendering, forceLayout, generateViewId, getAlpha, getAnimationMatrix, getBackground, getBaseline, getBottom, getBoundsOnScreen, getBoundsOnScreen, getContext, getContextMenuInfo, getDefaultSize, getDrawableState, getDrawingRect, getElevation, getFadingEdge, getFadingEdgeLength, getFocusable, getFocusables, getFocusedRect, getForeground, getForegroundGravity, getGlobalVisibleRect, getGlobalVisibleRect, getHandler, getHasOverlappingRendering, getHeight, getHitRect, getHorizontalScrollbarHeight, getHorizontalScrollbarThumbDrawable, getHorizontalScrollbarTrackDrawable, getId, getInverseMatrix, getKeyDispatcherState, getLayoutDirection, getLayoutParams, getLeft, getLocalVisibleRect, getLocationInWindow, getLocationOnScreen, getMatrix, getMeasuredHeight, getMeasuredHeightAndState, getMeasuredState, getMeasuredWidth, getMeasuredWidthAndState, getMinimumHeight, getMinimumWidth, getNextClusterForwardId, getNextFocusDownId, getNextFocusForwardId, getNextFocusLeftId, getNextFocusRightId, getNextFocusUpId, getOnFocusChangeListener, getOnLongClickListener, getOverScrollMode, getPaddingBottom, getPaddingEnd, getPaddingLeft, getPaddingRight, getPaddingStart, getPaddingTop, getParent, getPivotX, getPivotY, getRawLayoutDirection, getRawTextAlignment, getRawTextDirection, getRevealOnFocusHint, getRight, getRootView, getRotation, getRotationX, getRotationY, getScaleX, getScaleY, getScrollBarDefaultDelayBeforeFade, getScrollBarFadeDuration, getScrollBarSize, getScrollBarStyle, getScrollIndicators, getScrollX, getScrollY, getStateListAnimator, getSuggestedMinimumHeight, getSuggestedMinimumWidth, getTag, getTextAlignment, getTextDirection, getTooltipText, getTooltipView, getTop, getTouchables, getTransitionAlpha, getTransitionName, getTranslationX, getTranslationY, getTranslationZ, getVerticalFadingEdgeLength, getVerticalScrollbarThumbDrawable, getVerticalScrollbarTrackDrawable, getVerticalScrollbarWidth, getViewRoot, getViewTreeObserver, getVisibility, getWidth, getWindowAttachCount, getWindowVisibility, getX, getY, getZ, handleScrollBarDragging, hasExplicitFocusable, hasFocusable, hasIdentityMatrix, hasNestedScrollingParent, hasOnClickListeners, hasOnLongClickListeners, hasOverlappingRendering, hasTranslationTransientState, hasWindowFocus, invalidate, invalidateDrawable, isActivated, isAttachedToWindow, isClickable, isContextClickable, isDuplicateParentStateEnabled, isEnabled, isFocusable, isFocusableInTouchMode, isFocused, isFocusedByDefault, isForegroundInsidePadding, isHapticFeedbackEnabled, isHorizontalFadingEdgeEnabled, isHorizontalScrollBarEnabled, isHovered, isInLayout, isInScrollingContainer, isInTouchMode, isKeyboardNavigationCluster, isLaidOut, isLayoutDirectionInherited, isLayoutDirectionResolved, isLayoutRequested, isLayoutRtl, isLongClickable, isNestedScrollingEnabled, isPaddingRelative, isPivotSet, isPressed, isRootNamespace, isScrollbarFadingEnabled, isSelected, isShowingLayoutBounds, isShown, isSoundEffectsEnabled, isTemporarilyDetached, isTextAlignmentInherited, isTextAlignmentResolved, isTextDirectionInherited, isTextDirectionResolved, isVerticalFadingEdgeEnabled, isVerticalScrollBarEnabled, isVerticalScrollBarHidden, keyboardNavigationClusterSearch, mapRectFromViewToScreenCoords, measure, mergeDrawableStates, offsetLeftAndRight, offsetTopAndBottom, onAttachedToWindow, onCancelPendingInputEvents, onCreateContextMenu, onDetachedFromWindow, onDragEvent, onDraw, onDrawForeground, onDrawScrollBars, onFinishTemporaryDetach, onFocusChanged, onHoverChanged, onHoverEvent, onKeyDown, onKeyShortcut, onKeyUp, onResolveDrawables, onRtlPropertiesChanged, onScrollChanged, onStartTemporaryDetach, onVisibilityAggregated, onVisibilityChanged, onWindowFocusChanged, onWindowVisibilityChanged, overScrollBy, performButtonActionOnTouchDown, performClick, performContextClick, performContextClick, performHapticFeedback, performHapticFeedback, performLongClick, performLongClick, playSoundEffect, pointInView, post, postDelayed, postInvalidate, postInvalidateDelayed, postInvalidateOnAnimation, postOnAnimation, postOnAnimationDelayed, refreshDrawableState, removeCallbacks, removeOnAttachStateChangeListener, removeOnLayoutChangeListener, requestFocus, requestFocus, requestRectangleOnScreen, requestRectangleOnScreen, requireViewById, resetPivot, resolveSize, resolveSizeAndState, scheduleDrawable, scrollBy, setActivated, setAlpha, setAnimationMatrix, setBackground, setBottom, setClickable, setContextClickable, setDuplicateParentStateEnabled, setElevation, setEnabled, setFocusable, setFocusable, setFocusableInTouchMode, setFocusedByDefault, setFocusedInCluster, setForeground, setFrame, setHapticFeedbackEnabled, setHasTransientState, setHasTranslationTransientState, setHorizontalFadingEdgeEnabled, setHorizontalScrollBarEnabled, setHorizontalScrollbarThumbDrawable, setHorizontalScrollbarTrackDrawable, setHovered, setId, setIsRootNamespace, setKeyboardNavigationCluster, setLayoutDirection, setLayoutParams, setLeft, setLongClickable, setMeasuredDimension, setMinimumHeight, setMinimumWidth, setNestedScrollingEnabled, setNextClusterForwardId, setNextFocusDownId, setNextFocusForwardId, setNextFocusLeftId, setNextFocusRightId, setNextFocusUpId, setOnClickListener, setOnContextClickListener, setOnCreateContextMenuListener, setOnDragListener, setOnFocusChangeListener, setOnGenericMotionListener, setOnHoverListener, setOnKeyListener, setOnLongClickListener, setOnScrollChangeListener, setOnTouchListener, setOverScrollMode, setPadding, setPaddingRelative, setPivotX, setPivotY, setPressed, setRevealOnFocusHint, setRight, setRotation, setRotationX, setRotationY, setScaleX, setScaleY, setScrollBarDefaultDelayBeforeFade, setScrollBarFadeDuration, setScrollbarFadingEnabled, setScrollBarSize, setScrollBarStyle, setScrollIndicators, setScrollIndicators, setScrollX, setScrollY, setSelected, setSoundEffectsEnabled, setStateListAnimator, setTag, setTextAlignment, setTextDirection, setTooltipText, setTop, setTransitionAlpha, setTransitionName, setTransitionVisibility, setTranslationX, setTranslationY, setTranslationZ, setVerticalFadingEdgeEnabled, setVerticalScrollBarEnabled, setVerticalScrollbarThumbDrawable, setVerticalScrollbarTrackDrawable, setVisibility, setWillNotDraw, setX, setY, setZ, showContextMenu, showContextMenu, sp, startActionMode, startActionMode, startDragAndDrop, startNestedScroll, stopNestedScroll, toGlobalMotionEvent, toLocalMotionEvent, toString, transformFromViewToWindowSpace, transformMatrixToGlobal, transformMatrixToLocal, unscheduleDrawable, unscheduleDrawable, verifyDrawable, willNotDraw`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface icyllis.modernui.view.ViewParent

  `canResolveLayoutDirection, canResolveTextAlignment, canResolveTextDirection, createContextMenu, getLayoutDirection, getParent, getTextAlignment, getTextDirection, isLayoutDirectionResolved, isLayoutRequested, isTextAlignmentResolved, isTextDirectionResolved, keyboardNavigationClusterSearch`

- ## Constructor Details

  - ### HorizontalScrollView

    public HorizontalScrollView(Context context)

- ## Method Details

  - ### setEdgeEffectColor

    public void setEdgeEffectColor(@ColorInt int color)
    Sets the edge effect color for both left and right edge effects.
    Parameters:
      `color` - The color for the edge effects.
    See Also:
      - `setLeftEdgeEffectColor(int)`
      - `setRightEdgeEffectColor(int)`
      - `getLeftEdgeEffectColor()`
      - `getRightEdgeEffectColor()`

  - ### setRightEdgeEffectColor

    public void setRightEdgeEffectColor(@ColorInt int color)
    Sets the right edge effect color.
    Parameters:
      `color` - The color for the right edge effect.
    See Also:
      - `setLeftEdgeEffectColor(int)`
      - `setEdgeEffectColor(int)`
      - `getLeftEdgeEffectColor()`
      - `getRightEdgeEffectColor()`

  - ### setLeftEdgeEffectColor

    public void setLeftEdgeEffectColor(@ColorInt int color)
    Sets the left edge effect color.
    Parameters:
      `color` - The color for the left edge effect.
    See Also:
      - `setRightEdgeEffectColor(int)`
      - `setEdgeEffectColor(int)`
      - `getLeftEdgeEffectColor()`
      - `getRightEdgeEffectColor()`

  - ### getLeftEdgeEffectColor

    @ColorInt public int getLeftEdgeEffectColor()
    Returns the left edge effect color.
    Returns:
      The left edge effect color.
    See Also:
      - `setEdgeEffectColor(int)`
      - `setLeftEdgeEffectColor(int)`
      - `setRightEdgeEffectColor(int)`
      - `getRightEdgeEffectColor()`

  - ### getRightEdgeEffectColor

    @ColorInt public int getRightEdgeEffectColor()
    Returns the right edge effect color.
    Returns:
      The right edge effect color.
    See Also:
      - `setEdgeEffectColor(int)`
      - `setLeftEdgeEffectColor(int)`
      - `setRightEdgeEffectColor(int)`
      - `getLeftEdgeEffectColor()`

  - ### setLeftEdgeEffectBlendMode

    public void setLeftEdgeEffectBlendMode(@Nullable BlendMode blendMode)
    Sets the left edge effect blend mode, the default is `EdgeEffect.DEFAULT_BLEND_MODE`.
    Parameters:
      `blendMode` - The blend mode for the left edge effect.

  - ### setRightEdgeEffectBlendMode

    public void setRightEdgeEffectBlendMode(@Nullable BlendMode blendMode)
    Sets the right edge effect blend mode, the default is `EdgeEffect.DEFAULT_BLEND_MODE`.
    Parameters:
      `blendMode` - The blend mode for the right edge effect.

  - ### getLeftEdgeEffectBlendMode

    @Nullable public BlendMode getLeftEdgeEffectBlendMode()

  - ### getRightEdgeEffectBlendMode

    @Nullable public BlendMode getRightEdgeEffectBlendMode()

  - ### addView

    public void addView(@NonNull View child)
    Description copied from class: `ViewGroup`

    Adds a child view. If no layout parameters are already set on the child, the default parameters for this ViewGroup are set on the child.

    Note: do not invoke this method from `View.draw(Canvas)`, `View.onDraw(Canvas)`, `ViewGroup.dispatchDraw(Canvas)` or any related method.

    Overrides:
      `addView` in class `ViewGroup`
    Parameters:
      `child` - the child view to add
    See Also:
      - `ViewGroup.generateDefaultLayoutParams()`

  - ### addView

    public void addView(@NonNull View child, int index)
    Description copied from class: `ViewGroup`
    Adds a child view. If no layout parameters are already set on the child, the default parameters for this ViewGroup are set on the child.

    Note: do not invoke this method from `View.draw(Canvas)`, `View.onDraw(Canvas)`, `ViewGroup.dispatchDraw(Canvas)` or any related method.

    Overrides:
      `addView` in class `ViewGroup`
    Parameters:
      `child` - the child view to add
      `index` - the position at which to add the child
    See Also:
      - `ViewGroup.generateDefaultLayoutParams()`

  - ### addView

    public void addView(@NonNull View child, @NonNull ViewGroup.LayoutParams params)
    Description copied from class: `ViewGroup`
    Adds a child view with the specified layout parameters.

    Note: do not invoke this method from `View.draw(Canvas)`, `View.onDraw(Canvas)`, `ViewGroup.dispatchDraw(Canvas)` or any related method.

    Specified by:
      `addView` in interface `ViewManager`
    Overrides:
      `addView` in class `ViewGroup`
    Parameters:
      `child` - the child view to add
      `params` - the layout parameters to set on the child

  - ### addView

    public void addView(@NonNull View child, int index, @NonNull ViewGroup.LayoutParams params)
    Description copied from class: `ViewGroup`
    Adds a child view with the specified layout parameters.

    Note: do not invoke this method from `View.draw(Canvas)`, `View.onDraw(Canvas)`, `ViewGroup.dispatchDraw(Canvas)` or any related method.

    Overrides:
      `addView` in class `ViewGroup`
    Parameters:
      `child` - the child view to add
      `index` - the position at which to add the child or -1 to add last
      `params` - the layout parameters to set on the child

  - ### isFillViewport

    public boolean isFillViewport()
    Indicates whether this HorizontalScrollView's content is stretched to fill the viewport.
    Returns:
      True if the content fills the viewport, false otherwise.

  - ### setFillViewport

    public void setFillViewport(boolean fillViewport)
    Indicates this HorizontalScrollView whether it should stretch its content width to fill the viewport or not.
    Parameters:
      `fillViewport` - True to stretch the content's width to the viewport's boundaries, false otherwise.

  - ### isSmoothScrollingEnabled

    public boolean isSmoothScrollingEnabled()
    Returns:
      Whether arrow scrolling will animate its transition.

  - ### setSmoothScrollingEnabled

    public void setSmoothScrollingEnabled(boolean smoothScrollingEnabled)
    Set whether arrow scrolling will animate its transition.
    Parameters:
      `smoothScrollingEnabled` - whether arrow scrolling will animate its transition

  - ### onMeasure

    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec)
    Description copied from class: `View`
    Measure the view and its content to determine the measured width and the measured height. This method is invoked by `View.measure(int, int)` and should be overridden by subclasses to provide accurate and efficient measurement of their contents.

    CONTRACT: When overriding this method, you must call `View.setMeasuredDimension(int, int)` to store the measured width and height of this view. Failure to do so will trigger an `IllegalStateException`, thrown by `View.measure(int, int)`. Calling super.onMeasure() is a valid use.

    The base class implementation of measure defaults to the background size, unless a larger size is allowed by the MeasureSpec. Subclasses should override the base one to provide better measurements of their content.

    Overrides:
      `onMeasure` in class `FrameLayout`
    Parameters:
      `widthMeasureSpec` - width measure specification imposed by the parent `MeasureSpec`
      `heightMeasureSpec` - height measure specification imposed by the parent `MeasureSpec`

  - ### dispatchKeyEvent

    public boolean dispatchKeyEvent(@NonNull KeyEvent event)
    Description copied from class: `View`
    Dispatch a key event to the next view on the focus path. This path runs from the top of the view tree down to the currently focused view. If this view has focus, it will dispatch to itself. Otherwise it will dispatch the next node down the focus path. This method also fires any key listeners.
    Overrides:
      `dispatchKeyEvent` in class `ViewGroup`
    Parameters:
      `event` - The key event to be dispatched.
    Returns:
      True if the event was handled, false otherwise.

  - ### executeKeyEvent

    public boolean executeKeyEvent(KeyEvent event)
    You can call this function yourself to have the scroll view perform scrolling from a key event, just as if the event had been dispatched to it by the view hierarchy.
    Parameters:
      `event` - The key event to execute.
    Returns:
      Return true if the event was handled, else false.

  - ### requestDisallowInterceptTouchEvent

    public void requestDisallowInterceptTouchEvent(boolean disallowIntercept)
    Description copied from interface: `ViewParent`
    Called when a child does not want this parent and its ancestors to intercept touch events with `ViewGroup.onInterceptTouchEvent(MotionEvent)`.

    This parent should pass this call onto its parents. This parent must obey this request for the duration of the touch (that is, only clear the flag after this parent has received an up or a cancel.

    Specified by:
      `requestDisallowInterceptTouchEvent` in interface `ViewParent`
    Overrides:
      `requestDisallowInterceptTouchEvent` in class `ViewGroup`
    Parameters:
      `disallowIntercept` - True if the child does not want the parent to intercept touch events.

  - ### onInterceptTouchEvent

    public boolean onInterceptTouchEvent(MotionEvent ev)
    Description copied from class: `ViewGroup`
    Implement this method to intercept all touch screen motion events. This allows you to watch events as they are dispatched to your children, and take ownership of the current gesture at any point.

    Using this function takes some care, as it has a fairly complicated interaction with `View.onTouchEvent(MotionEvent)`, and using it requires implementing that method as well as this one in the correct way. Events will be received in the following order:

    1. You will receive the down event here.
    2. The down event will be handled either by a child of this view group, or given to your own onTouchEvent() method to handle; this means you should implement onTouchEvent() to return true, so you will continue to see the rest of the gesture (instead of looking for a parent view to handle it). Also, by returning true from onTouchEvent(), you will not receive any following events in onInterceptTouchEvent() and all touch processing must happen in onTouchEvent() like normal.
    3. For as long as you return false from this function, each following event (up to and including the final up) will be delivered first here and then to the target's onTouchEvent().
    4. If you return true from here, you will not receive any following events: the target view will receive the same event but with the action `MotionEvent.ACTION_CANCEL`, and all further events will be delivered to your onTouchEvent() method and no longer appear here.
    Overrides:
      `onInterceptTouchEvent` in class `ViewGroup`
    Parameters:
      `ev` - The motion event being dispatched down the hierarchy.
    Returns:
      Return true to steal motion events from the children and have them dispatched to this ViewGroup through onTouchEvent(). The current target will receive an ACTION_CANCEL event, and no further messages will be delivered here.

  - ### onTouchEvent

    public boolean onTouchEvent(@NonNull MotionEvent ev)
    Description copied from class: `View`
    Implement this method to handle touch screen motion events.

    If this method is used to detect click actions, it is recommended that the actions be performed by implementing and calling `View.performClick()`. This will ensure consistent system behavior.

    Overrides:
      `onTouchEvent` in class `View`
    Parameters:
      `ev` - the touch event
    Returns:
      `true` if the event was handled by the view, `false` otherwise

  - ### onGenericMotionEvent

    public boolean onGenericMotionEvent(@NonNull MotionEvent event)
    Description copied from class: `View`
    Implement this method to handle generic motion events.

    Implementations of this method should check if this view ENABLED and CLICKABLE.

    Overrides:
      `onGenericMotionEvent` in class `View`
    Parameters:
      `event` - the generic motion event being processed.
    Returns:
      `true` if the event was consumed by the view, `false` otherwise

  - ### shouldDelayChildPressedState

    public boolean shouldDelayChildPressedState()
    Description copied from class: `ViewGroup`
    Return true if the pressed state should be delayed for children or descendants of this ViewGroup. Generally, this should be done for containers that can scroll, such as a List. This prevents the pressed state from appearing when the user is actually trying to scroll the content.

    The default implementation returns true for compatibility reasons. Subclasses that do not scroll should generally override this method and return false.

    Overrides:
      `shouldDelayChildPressedState` in class `ViewGroup`

  - ### onOverScrolled

    protected void onOverScrolled(int scrollX, int scrollY, boolean clampedX, boolean clampedY)
    Description copied from class: `View`
    Called by `View.overScrollBy(int, int, int, int, int, int, int, int, boolean)` to respond to the results of an over-scroll operation.
    Overrides:
      `onOverScrolled` in class `View`
    Parameters:
      `scrollX` - New X scroll value in pixels
      `scrollY` - New Y scroll value in pixels
      `clampedX` - True if scrollX was clamped to an over-scroll boundary
      `clampedY` - True if scrollY was clamped to an over-scroll boundary

  - ### pageScroll

    public boolean pageScroll(int direction)

    Handles scrolling in response to a "page up/down" shortcut press. This method will scroll the view by one page left or right and give the focus to the leftmost/rightmost component in the new visible area. If no component is a good candidate for focus, this scrollview reclaims the focus.

    Parameters:
      `direction` - the scroll direction: `View.FOCUS_LEFT` to go one page left or `View.FOCUS_RIGHT` to go one page right
    Returns:
      true if the key event is consumed by this method, false otherwise

  - ### fullScroll

    public boolean fullScroll(int direction)

    Handles scrolling in response to a "home/end" shortcut press. This method will scroll the view to the left or right and give the focus to the leftmost/rightmost component in the new visible area. If no component is a good candidate for focus, this scrollview reclaims the focus.

    Parameters:
      `direction` - the scroll direction: `View.FOCUS_LEFT` to go the left of the view or `View.FOCUS_RIGHT` to go the right
    Returns:
      true if the key event is consumed by this method, false otherwise

  - ### arrowScroll

    public boolean arrowScroll(int direction)
    Handle scrolling in response to a left or right arrow click.
    Parameters:
      `direction` - The direction corresponding to the arrow key that was pressed
    Returns:
      True if we consumed the event, false otherwise

  - ### smoothScrollBy

    public final boolean smoothScrollBy(int delta)
    Like `View.scrollBy(int, int)`, but scroll smoothly instead of immediately.
    Parameters:
      `delta` - the number of pixels to scroll by on the X axis
    Returns:
      if actually scrolled

  - ### smoothScrollTo

    public final void smoothScrollTo(int x)
    Like `scrollTo(int, int)`, but scroll smoothly instead of immediately.
    Parameters:
      `x` - the position where to scroll on the X axis

  - ### computeHorizontalScrollRange

    protected int computeHorizontalScrollRange()

    The scroll range of a scroll view is the overall width of all of its children.

    Overrides:
      `computeHorizontalScrollRange` in class `View`
    Returns:
      the total horizontal range represented by the horizontal scrollbar
    See Also:
      - `View.computeHorizontalScrollExtent()`
      - `View.computeHorizontalScrollOffset()`

  - ### computeHorizontalScrollOffset

    protected int computeHorizontalScrollOffset()
    Description copied from class: `View`

    Compute the horizontal offset of the horizontal scrollbar's thumb within the horizontal range. This value is used to compute the position of the thumb within the scrollbar's track.

    The range is expressed in arbitrary units that must be the same as the units used by `View.computeHorizontalScrollRange()` and `View.computeHorizontalScrollExtent()`.

    The default offset is the scroll offset of this view.

    Overrides:
      `computeHorizontalScrollOffset` in class `View`
    Returns:
      the horizontal offset of the scrollbar's thumb
    See Also:
      - `View.computeHorizontalScrollRange()`
      - `View.computeHorizontalScrollExtent()`

  - ### measureChild

    protected void measureChild(View child, int parentWidthMeasureSpec, int parentHeightMeasureSpec)
    Description copied from class: `ViewGroup`
    Ask one of the children of this view to measure itself, taking into account both the MeasureSpec requirements for this view and its padding. The heavy lifting is done in getChildMeasureSpec.
    Overrides:
      `measureChild` in class `ViewGroup`
    Parameters:
      `child` - The child to measure
      `parentWidthMeasureSpec` - The width requirements for this view
      `parentHeightMeasureSpec` - The height requirements for this view

  - ### measureChildWithMargins

    protected void measureChildWithMargins(View child, int parentWidthMeasureSpec, int widthUsed, int parentHeightMeasureSpec, int heightUsed)
    Description copied from class: `ViewGroup`
    Ask one of the children of this view to measure itself, taking into account both the MeasureSpec requirements for this view and its padding and margins. The child must have MarginLayoutParams The heavy lifting is done in getChildMeasureSpec.
    Overrides:
      `measureChildWithMargins` in class `ViewGroup`
    Parameters:
      `child` - The child to measure
      `parentWidthMeasureSpec` - The width requirements for this view
      `widthUsed` - Extra space that has been used up by the parent horizontally (possibly by other children of the parent)
      `parentHeightMeasureSpec` - The height requirements for this view
      `heightUsed` - Extra space that has been used up by the parent vertically (possibly by other children of the parent)

  - ### computeScroll

    public void computeScroll()
    Description copied from class: `View`
    Called by a parent to request that a child update its values for mScrollX and mScrollY if necessary. This will typically be done if the child is animating a scroll using a Scroller.
    Overrides:
      `computeScroll` in class `View`

  - ### computeScrollDeltaToGetChildRectOnScreen

    protected int computeScrollDeltaToGetChildRectOnScreen(Rect rect)
    Compute the amount to scroll in the X direction in order to get a rectangle completely on the screen (or, if taller than the screen, at least the first screen size chunk of it).
    Parameters:
      `rect` - The rect.
    Returns:
      The scroll delta.

  - ### requestChildFocus

    public void requestChildFocus(View child, View focused)
    Description copied from interface: `ViewParent`
    Called when a child of this parent wants focus
    Specified by:
      `requestChildFocus` in interface `ViewParent`
    Overrides:
      `requestChildFocus` in class `ViewGroup`
    Parameters:
      `child` - The child of this ViewParent that wants focus. This view will contain the focused view. It is not necessarily the view that actually has focus.
      `focused` - The view that is a descendant of child that actually has focus

  - ### onRequestFocusInDescendants

    protected boolean onRequestFocusInDescendants(int direction, Rect previouslyFocusedRect)
    When looking for focus in children of a scroll view, need to be a little more careful not to give focus to something that is scrolled off-screen.

    This is more expensive than the default `ViewGroup` implementation, otherwise this behavior might have been made the default.

    Overrides:
      `onRequestFocusInDescendants` in class `ViewGroup`
    Parameters:
      `direction` - One of FOCUS_UP, FOCUS_DOWN, FOCUS_LEFT, and FOCUS_RIGHT
      `previouslyFocusedRect` - The rectangle (in this View's coordinate system) to give a finer grained hint about where focus is coming from. May be null if there is no hint.
    Returns:
      Whether focus was taken.

  - ### requestChildRectangleOnScreen

    public boolean requestChildRectangleOnScreen(View child, Rect rectangle, boolean immediate)
    Description copied from interface: `ViewParent`
    Called when a child of this group wants a particular rectangle to be positioned onto the screen. `ViewGroup`s overriding this can trust that:
    - child will be a direct child of this group
    - rectangle will be in the child's content coordinates

    `ViewGroup`s overriding this should uphold the contract:

    - nothing will change if the rectangle is already visible
    - the view port will be scrolled only just enough to make the rectangle visible
    Specified by:
      `requestChildRectangleOnScreen` in interface `ViewParent`
    Overrides:
      `requestChildRectangleOnScreen` in class `ViewGroup`
    Parameters:
      `child` - The direct child making the request.
      `rectangle` - The rectangle in the child's coordinates the child wishes to be on the screen.
      `immediate` - True to forbid animated or delayed scrolling, false otherwise
    Returns:
      Whether the group scrolled to handle the operation

  - ### requestLayout

    public void requestLayout()
    Description copied from class: `View`
    Call this when something has changed which has invalidated the layout of this view. This will schedule a layout pass of the view tree. This should not be called while the view hierarchy is currently in a layout pass (`View.isInLayout()`. If layout is happening, the request may be honored at the end of the current layout pass (and then layout will run again) or after the current frame is drawn and the next layout occurs.

    Subclasses which override this method should call the superclass method to handle possible request-during-layout errors correctly.

    Specified by:
      `requestLayout` in interface `ViewParent`
    Overrides:
      `requestLayout` in class `View`

  - ### onLayout

    protected void onLayout(boolean changed, int l, int t, int r, int b)
    Description copied from class: `View`
    Called from `View.layout(int, int, int, int)` when this view should assign a size and position to each of its children.

    Derived classes with children should override this method and call layout on each of their children.

    Overrides:
      `onLayout` in class `FrameLayout`
    Parameters:
      `changed` - This is a new size or position for this view
      `l` - Left position, relative to parent
      `t` - Top position, relative to parent
      `r` - Right position, relative to parent
      `b` - Bottom position, relative to parent

  - ### onSizeChanged

    protected void onSizeChanged(int w, int h, int oldw, int oldh)
    Description copied from class: `View`
    Called when width or height changed
    Overrides:
      `onSizeChanged` in class `View`
    Parameters:
      `w` - new width
      `h` - new height
      `oldw` - previous width
      `oldh` - previous height

  - ### fling

    public void fling(int velocityX)
    Fling the scroll view
    Parameters:
      `velocityX` - The initial velocity in the X direction. Positive numbers mean that the finger/cursor is moving down the screen, which means we want to scroll towards the left.

  - ### scrollTo

    public void scrollTo(int x, int y)
    Set the scrolled position of your view. This will cause a call to `View.onScrollChanged(int, int, int, int)` and the view will be invalidated.

    This version also clamps the scrolling to the bounds of our child.

    Overrides:
      `scrollTo` in class `View`
    Parameters:
      `x` - the x position to scroll to
      `y` - the y position to scroll to

  - ### draw

    public void draw(@NonNull Canvas canvas)
    Description copied from class: `View`
    Base method that directly draws this view and its background, foreground, overlay and all children to the given canvas. When implementing a view, override `View.onDraw(Canvas)` instead of this.

    This is not the entry point for the view system to draw.

    Overrides:
      `draw` in class `View`
    Parameters:
      `canvas` - the canvas to draw content